=== debian/changelog ===
performous (1.3.0+ds-2) unstable; urgency=medium

  * Team Upload
  * Fix FTBFS with ffmpeg 7.0 (Closes: #1072444, #1081353, #1081354)
  * Set Rules-Requires-Root: no

 -- Alexandre Detiste <tchet@debian.org>  Fri, 29 Nov 2024 17:47:59 +0100

performous (1.3.0+ds-1) unstable; urgency=medium

  * New upstream version 1.3.0.

 -- Markus Koschany <apo@debian.org>  Fri, 15 Sep 2023 13:31:12 +0200

performous (1.3.0~rc1+ds-2) unstable; urgency=medium

  * Remove libopenblas-dev from Build-Depends. The library is not available on
    several architectures.
  * Add no-Werror.patch. Don't fail if there are compiler warnings.

 -- Markus Koschany <apo@debian.org>  Thu, 07 Sep 2023 17:09:44 +0200

performous (1.3.0~rc1+ds-1) unstable; urgency=medium

  * New upstream version 1.3.0~rc1+ds. (Closes: #1023125)
    - Repack the tarball and include the ced library.
    - New release builds fine with latest ffmpeg version in Debian.
      (Closes: #1041505)
  * Update debian/watch and track latest releases on github.com.
  * d/control: Update the list of build-dependencies.
  * Drop all existing patches because they are obsolete.
  * Add ced.patch to fix a FTBFS.
  * Stop replacing Droid Sans Mono with Noto Mono.
  * Drop performous-tools binary package because this needs to be packaged
    separately now.
  * Update debian/copyright and README.source.

 -- Markus Koschany <apo@debian.org>  Wed, 06 Sep 2023 20:21:15 +0200
