=== debian/rules ===
#!/usr/bin/make -f

ifeq (,$(filter terse,${DEB_BUILD_OPTIONS}))
export DH_VERBOSE=1
export V=1
export VERBOSE=1
endif

LC_ALL:=C.UTF-8
export LC_ALL

DEB_HOST_ARCH?=$(shell dpkg-architecture -qDEB_HOST_ARCH)

OUR_CPPFLAGS:=
OUR_CXXFLAGS:=
OUR_LDFLAGS:=	-Wl,--as-needed

# needed so top-level exceptions are displayed as fatal errors for users
OUR_CPPFLAGS+=	-DNDEBUG

ifneq (,$(filter ${DEB_HOST_ARCH},armel m68k mips mipsel powerpc powerpcspe sh4))
OUR_LDFLAGS+=	-Wl,--start-group -latomic
endif

export DEB_BUILD_MAINT_OPTIONS := hardening=+all
export DEB_CPPFLAGS_MAINT_APPEND := ${OUR_CPPFLAGS}
export DEB_CXXFLAGS_MAINT_APPEND := ${OUR_CXXFLAGS}
export DEB_LDFLAGS_MAINT_APPEND := ${OUR_LDFLAGS}

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_VERBOSE_MAKEFILE=ON \
		-DCMAKE_INSTALL_PREFIX=/usr

override_dh_install:
	dh_install
	mkdir -p debian/performous/usr/games
	mv debian/performous/usr/bin/performous debian/performous/usr/games/
	rmdir --ignore-fail-on-non-empty debian/performous/usr/bin
	mkdir -p debian/performous/usr/share/icons/hicolor/scalable/apps
	mv debian/performous/usr/share/pixmaps/performous.svg \
		debian/performous/usr/share/icons/hicolor/scalable/apps/
	rmdir --ignore-fail-on-non-empty debian/performous/usr/share/pixmaps
	mkdir -p debian/performous/usr/share/man/man6
	mv debian/performous/usr/share/man/performous.6.gz \
		debian/performous/usr/share/man/man6/performous.6.gz
