=== debian/watch ===
version=4
opts=uversionmangle=s/(\d)[\.\-]?((rc|pre|dev|beta|alpha|b|a)\d*)$/$1~$2/,dversionmangle=s/\+(dfsg|debian|ds|repack|repacked)// \
  https://github.com/performous/performous/tags .*/@ANY_VERSION@@ARCHIVE_EXT@
