## performous 1.3.1%2Bds

=== CMakeLists.txt ===
--- 
+++ 
@@ -17,7 +17,7 @@
     git_describe(PROJECT_VERSION --tags)
     if(NOT PROJECT_VERSION)
         message("No project version found. Falling back onto default versioning strategy.")
-        set(PROJECT_VERSION "1.3+")
+        set(PROJECT_VERSION "1.3.1")
     endif()
 else()
     set(PROJECT_VERSION "${PERFORMOUS_VERSION}")
@@ -82,12 +82,12 @@
 	endif()
 	string(APPEND CMAKE_INSTALL_PREFIX "Performous.app/Contents")
 	set(CMAKE_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}")
-	set(CMAKE_INSTALL_DATAROOTDIR "${CMAKE_INSTALL_PREFIX}/Resources")
+	set(CMAKE_INSTALL_DATAROOTDIR "Resources")
 	set(CMAKE_INSTALL_DATADIR "${CMAKE_INSTALL_DATAROOTDIR}")
-	set(CMAKE_INSTALL_LOCALEDIR "${CMAKE_INSTALL_DATAROOTDIR}/Locale")
-	set(CMAKE_INSTALL_SYSCONFDIR "${CMAKE_INSTALL_PREFIX}/Resources/etc")
-	set(CMAKE_INSTALL_BINDIR "${CMAKE_INSTALL_PREFIX}/MacOS")
-	set(CMAKE_INSTALL_MANDIR "${CMAKE_INSTALL_PREFIX}/Resources/man/man6")
+	set(CMAKE_INSTALL_LOCALEDIR "${CMAKE_INSTALL_DATADIR}/Locale")
+	set(CMAKE_INSTALL_SYSCONFDIR "${CMAKE_INSTALL_DATADIR}/etc")
+	set(CMAKE_INSTALL_BINDIR "MacOS")
+	set(CMAKE_INSTALL_MANDIR "${CMAKE_INSTALL_DATADIR}/man/man6")
 endif()
 
 set(CMAKE_CXX_FLAGS_RelWithDebInfo "${CMAKE_CXX_FLAGS_RelWithDebInfo} -O3")
