=== docs/CMakeLists.txt ===
if(UNIX)
	add_subdirectory(man)
endif(UNIX)
