=== debian/changelog ===
performous (1.3.1+ds-3ubuntu2) resolute; urgency=medium

  * No-change rebuild for ffmpeg 8.

 -- Rik Mills <rikmills@kde.org>  Wed, 31 Dec 2025 22:17:02 +0000

performous (1.3.1+ds-3ubuntu1) resolute; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - d/p/fix_ftbfs_boost.patch: Apply upstream patch to fix FTBS with boost.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 24 Dec 2025 09:18:15 +0100

performous (1.3.1+ds-3) unstable; urgency=medium

  * Team upload.

  [ lizhuoheng ]
  * Fix FTBFS with FFmpeg 8 (Closes: #1122941)

 -- Alexandre Detiste <tchet@debian.org>  Sat, 20 Dec 2025 14:48:15 +0100

performous (1.3.1+ds-2ubuntu2) resolute; urgency=medium

  * No-change rebuild for icu soname.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 02 Dec 2025 22:50:48 +0100

performous (1.3.1+ds-2ubuntu1) resolute; urgency=medium

  * d/p/fix_ftbfs_boost.patch: Apply upstream patch to fix FTBS with boost.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Tue, 04 Nov 2025 21:47:07 +0000

performous (1.3.1+ds-2build1) resolute; urgency=medium

  * No-change rebuild for libportmidi2.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 31 Oct 2025 22:01:51 +0000

performous (1.3.1+ds-2) unstable; urgency=medium

  * Team upload.
  * Fix build with CMake 4
    Closes: #1113397

 -- Andreas Tille <tille@debian.org>  Sun, 26 Oct 2025 15:59:52 +0100

performous (1.3.1+ds-1) unstable; urgency=medium

  [ Helmut Grohne ]
  * Team upload.
  * Improve cross building: Don't run unit tests when DEB_BUILD_OPTIONS
    contains nocheck. (Closes: #1095962)

  [ Andreas Tille ]
  * Fix watch file
  * Import ced into multi tarball source
  * Standards-Version: 4.7.2
  * Remove obsolete field Name from debian/upstream/metadata
  * Rely on pre-initialized dpkg-architecture variables.

 -- Andreas Tille <tille@debian.org>  Thu, 11 Sep 2025 21:12:19 +0200
