=== debian/control ===
Source: performous
Section: games
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Miriam Ruiz <miriam@debian.org>,
 Markus Koschany <apo@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 gettext,
 help2man,
 libaubio-dev,
 libavcodec-dev,
 libavformat-dev,
 libboost-filesystem-dev,
 libboost-iostreams-dev,
 libboost-locale-dev,
 libboost-program-options-dev,
 libboost-system-dev,
 libcpprest-dev,
 libepoxy-dev,
 libfftw3-dev,
 libfmt-dev,
 libfreetype-dev,
 libglm-dev,
 libgmock-dev,
 libgtest-dev,
 libicu-dev,
 libjpeg-dev,
 libopencv-dev,
 libpango1.0-dev,
 libportmidi-dev [linux-any],
 librsvg2-dev,
 libsdl2-dev,
 libssl-dev,
 libswscale-dev,
 libxml++2.6-dev,
 nlohmann-json3-dev,
 portaudio19-dev,
Standards-Version: 4.7.2
Vcs-Git: https://salsa.debian.org/games-team/performous.git
Vcs-Browser: https://salsa.debian.org/games-team/performous
Homepage: https://performous.org/

Package: performous
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 fretsonfire-songs-muldjord,
 fretsonfire-songs-sectoid,
Description: karaoke game that allows user supplied songs
 A karaoke, band and dancing game where one or more players perform a song
 and the game scores their performances. Supports songs in UltraStar,
 Frets on Fire and StepMania formats. Microphones and instruments from
 SingStar, Guitar Hero and Rock Band as well as some dance pads are
 autodetected.
