=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,7 @@
 LC_ALL:=C.UTF-8
 export LC_ALL
 
-DEB_HOST_ARCH?=$(shell dpkg-architecture -qDEB_HOST_ARCH)
+include /usr/share/dpkg/architecture.mk
 
 OUR_CPPFLAGS:=
 OUR_CXXFLAGS:=
@@ -33,17 +33,17 @@
 override_dh_auto_configure:
 	dh_auto_configure -- \
 		-DCMAKE_VERBOSE_MAKEFILE=ON \
-		-DCMAKE_INSTALL_PREFIX=/usr
+		-DCMAKE_INSTALL_PREFIX=/usr \
+		-DBUILD_TESTS=$(if $(filter nocheck,$(DEB_BUILD_OPTIONS)),OFF,ON) \
+		-DCMAKE_POLICY_VERSION_MINIMUM=3.5
 
-override_dh_install:
-	dh_install
+execute_after_dh_install:
 	mkdir -p debian/performous/usr/games
 	mv debian/performous/usr/bin/performous debian/performous/usr/games/
 	rmdir --ignore-fail-on-non-empty debian/performous/usr/bin
 	mkdir -p debian/performous/usr/share/icons/hicolor/scalable/apps
-	mv debian/performous/usr/share/pixmaps/performous.svg \
-		debian/performous/usr/share/icons/hicolor/scalable/apps/
-	rmdir --ignore-fail-on-non-empty debian/performous/usr/share/pixmaps
+	cp -a debian/performous/usr/share/games/performous/themes/default/icon.svg \
+		debian/performous/usr/share/icons/hicolor/scalable/apps/performous.svg
 	mkdir -p debian/performous/usr/share/man/man6
 	mv debian/performous/usr/share/man/performous.6.gz \
 		debian/performous/usr/share/man/man6/performous.6.gz
